#include "except.ri"
#include <iostream>

//using namespace javaSys;

int main (int argc, char** argv)
{
	ctl::vector<ctl::location> loc = ctl::readLocation("locs.txt");
	if (loc.size() < 1)
	{
		std::cerr << "No valid location found.\n";
		return 1;
	}

	for(int P=0; P<loc.size(); P++)
	{
		ctl::link lnk(loc[P]);
		BarRI add;

		try
		{ 
			add = BarRI(lnk);
		}
		catch(ctl::exception &e)
		{ 
			std::cout << e <<"\n"; 
		}

		if(!!add)
		{
			try
			{
				int res = add.add(4,5);
				std::cout<< loc[P] << " -> Add: 4 + 5 = " << res << "\n";
			}
			catch(ctl::exception &e)
			{ 
				std::cout << e <<"\n"; 
			}
			catch (wire::myException &e)
			{
				std::cout << "user-defined exception: " << e.message() << "\n";
			}
		}
	}
	return 0;
}
