#include <libunix.ri>

int main (int argc, char **argv)
{
	ctl::vector<ctl::location> loc = ctl::readLocation("locs.txt");
	if (loc.size() < 1)
	{
		std::cerr << "No valid location found.\n";
		return 1;
	}
	ctl::link lnk(loc[0]);

	try
	{
		NCLib::Unix::use(lnk);
		NCLib::Unix ux;
		std::string foo = ux.mkfifo();
		std::cout << foo << "\n";
		unlink(foo.c_str());
	}
	catch (ctl::exception &e)
	{
		std::cerr << e << "\n";
	}
	return 0;
}
