#include <mlab_multiindex_interface.ci>
#include <client.h>

int main (int argc, char **argv)
{
	ctl::vector<ctl::location> loc = ctl::readLocation("locs.txt");
	if (loc.size() < 1)
	{
		std::cerr << "No valid location found.\n";
		return 1;
	}

	for(int P=0; P<loc.size(); P++)
	{
		try
		{
			ctl::link lnk(loc[P]);
			MatlabMI::use(lnk);
			myMatrix res;
			double p = 2, m = 3;

			res = MatlabMI::multiindex_interface<myMatrix,double,double>(p, m);
			std::cout << "Multi-indices:\n" << res << "\n";
		}
		catch (ctl::exception &e)
		{
			std::cerr << e << "\n";
		}
	}

	return 0;
}
