package CTL;

import CTL.Types.*;
import ReflWrap.*;

import java.util.*;

/** Abstract base class for all remote interfaces */
public abstract class RI
{
	/** Process information */
	protected static Process proc = null;
	/** ObjectID */
	protected long objID = -1;
	/** PeerID */
	protected PeerID home = null;

	/** Retrieve the PeerID of this object
	 * @return PeerID
	 */
	public PeerID peerID ()
	{
		return home;
	}

	/** Set a PeerID for this object
	 * @param ID PeerID
	 */
	public void setPeerID (PeerID ID)
	{
		home = ID;
	}

	/** Retrieve the objID of this object
	 * @return ObjectID
	 */
	public long objID ()
	{
		return objID;
	}

	/** Set an objID for this object
	 * @param ID ObjectID
	 */
	public void setObjID (long ID)
	{
		objID=ID;
	}
	
	/** Set the communication process for this object
	 * @param prc Process
	 */
	public static void use (Process prc)
	{
		if (!prc.isAlive())
			new RuntimeException("Process "+prc+" not running.");
		proc=prc;
	}

	/** Retrieve the communication process of this object
	 * @return Process
	 */
	protected static Process proc ()
	{
		return null;
	}

	/** Retrieve the implementation class of this remote interface 
	 * @return Implementation class as string
	 */
	public String getBase ()
	{
		return null;
	}
}
