package CTL.Types;

import CTL.Serialize.*;
import NCLib.*;
import ReflWrap.*;

import java.io.*;
import java.lang.reflect.*;
import java.util.*;

// TODO: document
public class Function implements Writable
{
	private String retType, name;
	private String[] paramTypes;

	private static LinkedList<String> not = Strings.makeList("getBase", "use",
		"accept", "peerID");

	public Function (Method m)
	{
		this(new MethodInfo(m));
	}

	public Function (MethodInfo m)
	{
		name = m.name();
		retType = m.returns().name();
		paramTypes = m.params();
	}

	public String name ()
	{
		return name;
	}

	public String toString ()
	{
		
		return retType+" "+name+" ("+Strings.join(", ", paramTypes)+");";
	}

	public void read (SerialIn in) throws IOException, ClassNotFoundException, 
		InstantiationException, IllegalAccessException, InvocationTargetException
	{
		retType = in.readString();
		name = in.readString();
		//paramTypes = in.readArray(String.class);
		paramTypes = in.readArray(String.class, null);
	}

	public void write (SerialOut out) throws IOException, IllegalAccessException,
		InvocationTargetException, CTLException
	{
		out.writeString(retType);
		out.writeString(name);
		out.writeArray(paramTypes);
	}

	public static LinkedList<Function> getFunctions (Class cl)
	{
		ClassInfo cinfo = new ClassInfo(cl);
		LinkedList<Function> ret = new LinkedList<Function>();
		for (Method m : cinfo.meth_here())
		{
			Function func = new Function(m);
			if ((not.indexOf(func.name()) > -1) || (func.name().endsWith("_rr")))
				continue;
			ret.add(func);
		}
		return ret;
	}
}
