package CTL;

import CTL.Streams.*;
import CTL.Types.*;
import ReflWrap.*;

import java.io.*;
import java.lang.reflect.*;

/** Persistence for CTL objects */
public class Vault
{
	public static Object read (InputStream in) throws IOException, 
		ClassNotFoundException, InstantiationException, IllegalAccessException,
		InvocationTargetException, CTLException
	{
		OIStream in2 = new OIStream(in);
		TypeTree type = in2.serialRead(TypeTree.class);
		Object obj = in2.serialRead(type);
		return obj;
	}

	public static Object read (File fname) throws FileNotFoundException, 
		IOException, ClassNotFoundException, InstantiationException, 
		IllegalAccessException, InvocationTargetException, CTLException
	{
		FileInputStream fis = new FileInputStream(fname);
		Object obj = read(fis);
		fis.close();
		return obj;
	}
	
	public static void write (Object obj, TypeTree type, OutputStream out) 
		throws IOException, IllegalAccessException, InvocationTargetException, 
		CTLException
	{
		OOStream out2 = new OOStream(out);
		out2.serialWrite(type);
		out2.serialWrite(obj);
		out2.flush();
	}

	public static void write (Object obj, TypeTree type, File fname) throws 
		FileNotFoundException, IOException, IllegalAccessException, 
		InvocationTargetException, CTLException
	{
		FileOutputStream fos = new FileOutputStream(fname);
		write(obj, type, fos);
		fos.close();
	}
}
