package Example;

import CTL.*;
import CTL.CCompat.*;
import CTL.Types.*;
import javaSys.*;
import ReflWrap.*;

/** Simple GNU scientific library client */
public class GSL
{
	public static void main (String args[])
	{
		Location loc = Location.parseFile("locs.txt").get(0);
		CTL.Process proc = new CTL.Process(loc);
		LinalgCI.use(proc);
		
		CArray<Double> mat = new CArray<Double>(16);
		for (int i=0;i<16;i++)
			mat.set(i, Math.random());

		Tupel<Long,CArray<Double>> A = null;
		try
		{
			TypeTree[] tree = new TypeTree[2];
			tree[0] = new TypeTree(Long.class);
			tree[1] = new TypeTree(CArray.class, Double.class);
			A = new Tupel<Long,CArray<Double>>(tree);
			A.setItem(0, new Long(4));
			A.setItem(1, mat);
		}
		catch (Exception e)
		{
			RUtil.except(e);
		}
		
		CArray<Double> b = new CArray<Double>(4);
		for (int i=0;i<4;i++)
			b.set(i, Math.random());

		LinalgCI obj = new LinalgCI();
		CArray<Double> res = obj.solve_QR(A, b);
		System.out.println("solve_QR: "+res);
	}
}
