package NCLib;

import CTL.Types.*;

import java.lang.reflect.*;

public class LibUnix
{
	private final static String location = "./cpp/libunix/libunix.so lib";
	private static Class UnixCIClass;

	static
	{
		try
		{
			UnixCIClass = Class.forName("NCLib.UnixCI");
		}
		catch (ClassNotFoundException e)
		{
			UnixCIClass = null;
		}
	}

	private Object makeObj (Class cl, Class[] argtypes, Object[] argvals)
	{
		if (cl == null)
			return null;
		try
		{
			Constructor c = cl.getDeclaredConstructor(argtypes);
			/*Object result = c.invoke(argvals);
			return result;*/
		} catch (Exception e) {}
		return null;
	}

	private Object makeCall (Class cl, Object obj, String method, Class[] argtypes, 
		Object[] argvals)
	{
		if (cl == null)
			return null;
		try
		{
			Method m = cl.getDeclaredMethod(method, argtypes);
			Object result = m.invoke(obj, argvals);
			return result;
		} catch (Exception e) {}
		return null;
	}

	private Object makeCall (String method, Class[] argtypes, Object[] argvals)
	{
		// use()
		Location loc = new Location(location);
		CTL.Process proc = new CTL.Process(loc);
		Class[] args = new Class[1];
		args[0] = CTL.Process.class;
		Object[] args2 = new Object[1];
		args2[0] = proc;
		makeCall(UnixCIClass, null, "use", args, args2);
		// constructor
		Object tmp = makeObj(UnixCIClass, null, null);
		// the real call
		Object result = makeCall(UnixCIClass, tmp, method, argtypes, argvals);
		return result;
	}

	private Object makeCall (String method)
	{
		return makeCall(method, null, null);
	}

	public String mkfifo ()
	{
		return (String)makeCall("mkfifo");
	}

	public void system (String arg0)
	{
		Class[] args = new Class[1];
		args[0] = String.class;
		Object[] args2 = new Object[1]; 
		args2[0] = arg0;
		makeCall("system", args, args2);
	}
}
