package Test;

import CTL.*;
import CTL.Streams.*;
import CTL.Types.*;

import java.io.*;
import junit.framework.*;

/** Test case for Graph */
public class TGraph extends TestCase
{
	public void testGraph () 
	{
		try
		{
			Env.newLogger("test");
			
			Graph g = new Graph(0);
			g.addNode(new Node("A", 1));
			g.addNode(new Node("B", 2));
			g.addNode(new Node("C", 1));

			g.addEdge2(0, 1);
			g.addEdge2(1, 2);

			PipedOutputStream pout = new PipedOutputStream();
			PipedInputStream pin = new PipedInputStream(pout);
			OOStream out = new OOStream(pout);
			OIStream in = new OIStream(pin);

			out.serialWrite(g);
			out.writeInt(1337);
			out.flush();
			Reference.cleanup();
			Graph g2 = in.serialRead(Graph.class);
			int test = in.readInt();

			/*System.out.println(g);
			System.out.println(g2);*/
	
			assertTrue(g.equals(g2));
			assertTrue(test==1337);
		}
		catch (Exception e)
		{
			RUtil.except(e);
		}
	}

	public static void main (String[] args)
	{
		TGraph moo = new TGraph();
		moo.testGraph();
	}
}
