package Test;

import CTL.*;
import CTL.Streams.*;
import CTL.Types.*;

import java.io.*;
import java.lang.reflect.*;
import junit.framework.*;

/** Test case for CTL.Tupel 
 * @see CTL.Types.Tupel
 */
public class TTupel extends TestCase
{
	private OOStream out;
	private OIStream in;

	public static void main (String[] types)
	{
		try
		{
			TTupel moo = new TTupel();
			moo.testCase();
		}
		catch (Exception e)
		{
			RUtil.except(e);
		}
	}
	
	public TTupel () throws IOException, CTLException
	{
		Env.newLogger("test");
		PipedOutputStream pout = new PipedOutputStream();
		PipedInputStream pin = new PipedInputStream(pout);
		out = new OOStream(pout);
		in = new OIStream(pin);
	}

	public void testCase () throws IOException, ClassNotFoundException,
		InvocationTargetException, IllegalAccessException,
		InstantiationException, CTLException
	{
		Class[] t = new Class[3];
		t[0] = Integer.TYPE;
		t[1] = Float.TYPE;
		t[2] = String.class;
		Tupel tupel1 = new Tupel(t);
		tupel1.setItem(0, 5);
		tupel1.setItem(1, 2.0f);
		tupel1.setItem(2, "Moongoo!");
		out.serialWrite(tupel1);
		out.flush();
		Tupel tupel2 = in.readTupel(t);
		assertTrue(tupel1.equals(tupel2));
	}
}
